Program sknview;

{$RESOURCE icon.res}

Uses
  Windows, Messages, CommDlg, ShellAPI;

{$LINK unpacker.obj}
Procedure UnPack(Const Src; Var Dst); StdCall; External;

{$LINK dtext.obj}
Procedure dtext; External;

Function MemCmp(Const S1, S2; N: Dword): Integer; CDecl; External 'msvcrt.dll' name 'memcmp';
Function MemCpy(Var Dst; Const Src; N: Dword): Pointer; CDecl; External 'msvcrt.dll' name 'memcpy';
Function StrCpy(Var Dst; Const Src): Pointer; CDecl; External 'msvcrt.dll' name 'strcpy';

Const
  SKIN_BITMAP_POSE_LEFT   = 1;
  SKIN_BITMAP_POSE_RIGHT  = 2;
  SKIN_BITMAP_POSE_MIDDLE = 3;

  SKIN_BITMAP_MODE_ACTIVE   = 1;
  SKIN_BITMAP_MODE_INACTIVE = 0;

  SKIN_BUTTON_CLOSE    = 1;
  SKIN_BUTTON_MINIMIZE = 2;

Type
  TSkinParams = Packed Record
    Height:          Dword;
    Margins:         Packed Record
                       Right:  SmallInt;
                       Left:   SmallInt;
                       Bottom: SmallInt;
                       Top:    SmallInt;
                     End;
    Colors:          Packed Record
                       Active:   Packed Record
                                   Inner:  Dword;
                                   Outer:  Dword;
                                   Frame:  Dword;
                                 End;
                       Inactive: Packed Record
                                   Inner:  Dword;
                                   Outer:  Dword;
                                   Frame:  Dword;
                                 End;
                     End;
    SizeOfStdColors: Dword;
    StandardColors:  Packed Record
                       Frames:         Dword;
                       Grab:           Dword;
                       Work3DDark:     Dword;
                       Work3DLight:    Dword;
                       GrabText:       Dword;
                       Work:           Dword;
                       WorkButton:     Dword;
                       WorkButtonText: Dword;
                       WorkText:       Dword;
                       WorkGraph:      Dword;
                     End;
  End;

  PSkinParams = ^TSkinParams;

  TSkinButton = Packed Record
    Mode:   Dword;
    Left:   SmallInt;
    Top:    SmallInt;
    Width:  Word;
    Height: Word;
  End;

  TSkinButtons = Packed Array [0..0] Of TSkinButton;

  PSkinButtons = ^TSkinButtons;

  TSkinBitmapStruct = Packed Record
    Width:  Dword;
    Height: Dword;
    Raw:    Array [0..0] Of TRGBTriple;
  End;

  PSkinBitmapStruct = ^TSkinBitmapStruct;

  TSkinBitmap = Packed Record
    Pose:   Word;
    Mode:   Word;
    Bitmap: PSkinBitmapStruct;
  End;

  TSkinBitmaps = Packed Array [0..0] Of TSkinBitmap;

  PSkinBitmaps = ^TSkinBitmaps;

  TSkinHeader = Packed Record
    Signature: Dword;
    Version:   Dword;
    Params:    PSkinParams;
    Buttons:   Pointer;
    Bitmaps:   PSkinBitmaps;
  End;

  PSkinHeader = ^TSkinHeader;

  TPackedFile = Packed Record
    Signature:    Packed Array [0..3] Of Char; (* 'KPCK' *)
    UnpackedSize: Dword;                       (* size Of unpacked data*)
    PackMethod:   Dword;                       (* LZMA, CallTrick, NoCallTrick*)
    PackedData:   Packed Array [0..0] Of Char;
  End;

  PPackedFile = ^TPackedFile;

//---------------------------------
  TSkin = Packed Record
    Height:  Dword;
    Margins: Packed Record
               Right:  SmallInt;
               Left:   SmallInt;
               Bottom: SmallInt;
               Top:    SmallInt;
             End;
    Colors:  Packed Record
               Active:   Packed Record
                           Inner:  Dword;
                           Outer:  Dword;
                           Frame:  Dword;
                         End;
               Inactive: Packed Record
                           Inner:  Dword;
                           Outer:  Dword;
                           Frame:  Dword;
                         End;
             End;
    StandardColors:
             Packed Record
               Frames:         Dword;
               Grab:           Dword;
               Work3DDark:     Dword;
               Work3DLight:    Dword;
               GrabText:       Dword;
               Work:           Dword;
               WorkButton:     Dword;
               WorkButtonText: Dword;
               WorkText:       Dword;
               WorkGraph:      Dword;
             End;
  // ......................... //
  End;

Type
  TRGBQuadArray = Packed Array [0..0] Of TRGBQuad;
  PRGBQuadArray = ^TRGBQuadArray;

Var
  tmpBytesMiddleActive: PRGBQuadArray;
  tmpBytesLeftActive:   PRGBQuadArray;
  tmpBytesRightActive:  PRGBQuadArray;

  tmpBytesMiddleInactive: PRGBQuadArray;
  tmpBytesLeftInactive:   PRGBQuadArray;
  tmpBytesRightInactive:  PRGBQuadArray;

Const
 ClassName = 'WindowClass';

 HEAP_ZERO_MEMORY = 8;

 BORDER_SIZE = 5;

 WS_SKINNED_FIXED   = $4000000;
 WS_SKINNED_SIZABLE = $3000000;


Var
  WindowStyle:   Dword = WS_SKINNED_SIZABLE;
  Msg:           Windows.TMsg;
  WindowClass:   Windows.WNDCLASS;
  WLeft:         LongInt;
  WTop:          LongInt;
  WWidth:        LongInt = 320;
  WHeight:       LongInt = 200;
  hWindow:       Windows.HWND;
  hDC:           Windows.HDC;

  RBitmapWidthActive:  Dword;
  LBitmapWidthActive:  Dword;

  RBitmapWidthInactive:  Dword;
  LBitmapWidthInactive:  Dword;

  hBitmapMiddleActive: Windows.HBITMAP;
  hBitmapRightActive:  Windows.HBITMAP;
  hBitmapLeftActive:   Windows.HBITMAP;

// a - means active
  maBMPInfo:      Windows.BITMAPINFO;
  laBMPInfo:      Windows.BITMAPINFO;
  raBMPInfo:      Windows.BITMAPINFO;

  hBitmapMiddleInactive: Windows.HBITMAP;
  hBitmapRightInactive:  Windows.HBITMAP;
  hBitmapLeftInactive:   Windows.HBITMAP;

// i - means inactive
  miBMPInfo:      Windows.BITMAPINFO;
  liBMPInfo:      Windows.BITMAPINFO;
  riBMPInfo:      Windows.BITMAPINFO;

  Skin: TSkin;

  _display_width: Dword;
  fontSmoothing: Byte = 2;

  CaptionText: Array [0..255] Of Char;

Const
 (* Charset specifiers for DrawText *)
  DT_CP866_6X9         = $00000000;
  DT_CP866_8X16        = $10000000;
  DT_UTF_16LE_8X16     = $20000000;
  DT_UTF_8_8X16        = $30000000;

 (* Draw zero terminated string for DrawText *)
  DT_ZSTRING           = $80000000;

 (* Fill styles for DrawText *)
  DT_FILL_TRANSPARENT  = $00000000;
  DT_FILL_OPAQUE       = $40000000;

Type
  TButton = Packed Record
    ID:         Dword;
    Left:       LongInt;
    Top:        LongInt;
    Right:      LongInt;
    Bottom:     LongInt;
    Width:      Dword;
    LeftOffset: LongInt;
  End;

  PButton = ^TButton;

Const
  BUTTON_MINIMIZE = $FFFF;
  BUTTON_CLOSE    = 1;

Var
  ButtonMinimize: TButton;
  ButtonClose: TButton;

  CapturedButton: PButton = Nil;


Function rgb2bgr(Const RGB: Dword): Dword;
Asm
  shl eax, 8
  bswap eax
End;

(******************************** Functions needed for DrawText *******************************)
// first 2 functions are not StdCall

Procedure __sys_putpixel;//(X, Y: Integer; Color: Dword);
{     ->EAX     X coordinate       }
{       EBX     Y coordinate       }
{       ECX     xx RR GG BB        }
Asm
  pushad
  and ecx, $00ffffff
  push ecx // Color
  push ebx // Y
  push eax // X
  push hDC
  call Windows.SetPixel
  popad
End;

Function syscall_getpixel: Dword;//(X, Y: Integer): Dword;
{       ->EBX     Y * XSize + X    }
Asm
  push Windows.SM_CXSCREEN
  call Windows.GetSystemMetrics
  mov ecx, eax
  mov eax, ebx
  xor edx, edx
  div ecx
  push eax // Y
  push edx // X
  push hDC
  call Windows.GetPixel
  mov [esp + 32], eax // yes, [esp + 32], see syscall_getpixel in kernel.asm for details
End;

Function kernel_alloc(Bytes: Dword): Pointer; StdCall;
Begin
  Result := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, Bytes);;
End;

Function kernel_free(MemPtr: Pointer): Dword; StdCall;
Begin
  Result := Dword(Windows.HeapFree(GetProcessHeap, 0, MemPtr));
End;
(******************************************************)
// keep this function StdCall
Procedure DrawText(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags, Count: Dword); StdCall;
{
dtext:
; edx -> string
; esi = number Of characters
; ebx = output coordinates XXXXYYYY h
; ecx = char color and flags flRRGGBB h
; fl = ZBFFRSSS b
; Z=1: edx -> zero terminated string, esi = ?
; B=1: fill background with color eax
; R=1: edi -> user area for redirect
; FF=3: UTF-8 8x16, FF=2: UTF-16LE 8x16
; FF=1: cp866 8x16, FF=0: cp866 6x9
; SSS = (font multiplier)-1
; edi=1: force output
; flag CF=1 means that we deal with asciiz but need to draw no more than esi symbols
}
Begin
    Inc(X, BORDER_SIZE); Inc(Y, Skin.Height);
  Asm
    push Windows.SM_CXSCREEN      // procedure dtext uses
    call Windows.GetSystemMetrics // _display_width value
    mov _display_width, eax       //
    pushad
    mov ebx, X
    shl ebx, 16
    or  ebx, Y
    mov eax, ForeColor
    call rgb2bgr
    mov ecx, eax
    or  ecx, Flags
    mov eax, BackColor
    mov edi, eax // R=1: edi -> user area for redirect
    call rgb2bgr
    mov edx, Text
    mov esi, Count
    call dtext
    popad
  End;
End;

Procedure DrawCaption(Caption: PChar); StdCall;
Var
  WRect: Windows.TRect;
Begin
  Windows.GetWindowRect(hWindow, WRect);
  //DrawText(8, 8, Caption, Skin.StandardColors.GrabText, 0, DT_CP866_8X16 Or DT_ZSTRING, 0);
  Asm
    push Windows.SM_CXSCREEN      // procedure dtext uses
    call Windows.GetSystemMetrics // _display_width value
    mov _display_width, eax       //

    pushad
    movzx ebx, Skin.Margins.Left
    shl ebx, 16
    mov bx, Skin.Margins.Top
    mov eax, Skin.StandardColors.GrabText
    call rgb2bgr
    mov ecx, eax
    or  ecx, DT_CP866_8X16
    mov edx, Caption

// Calculate how many symbols 8x16 we can output:
// (Window.Right - Window.Left - Skin.Margins.Right - Skin.Margins.Left) Div 8
    mov eax, WRect.Right
    sub eax, WRect.Left
    movzx esi, Skin.Margins.Right
    sub eax, esi
    movzx esi, Skin.Margins.Left
    sub eax, esi
    shr eax, 3 // div 8
    mov esi, eax
    stc // ; flag CF=1 means that we deal with asciiz but need to draw no more than esi symbols

// call dtext._ // clc - 1 byte
    lea eax, [dtext + 1]
    call eax
    popad
  End;
End;

Procedure DrawButton(Left, Top, Width, Height: Integer; BackColor: Dword);
Var
  Rect: Windows.TRect;
Begin
  Inc(Left, BORDER_SIZE); Inc(Top, Skin.Height);
    Rect.Left := Left; Rect.Top := Top; Rect.Right := Left + Width + 1; Rect.Bottom := Top + Height + 1;
    Windows.SelectObject(hDC, Windows.GetStockObject(DC_PEN));
    Windows.SelectObject(hdc, Windows.GetStockObject(DC_BRUSH));
    With Rect Do Begin
      Windows.SetDCPenColor(hDC, rgb2bgr(BackColor) Shr 1 And $007F7F7F);
      // top line
      Windows.MoveToEx(hDC, Left + 1, Top, Nil);
      Windows.LineTo(hDC, Right - 1, Top);
      // bottom line
      Windows.MoveToEx(hDC, Left + 1, Bottom - 1, Nil);
      Windows.LineTo(hDC, Right - 1, Bottom - 1);
      // left line
      Windows.MoveToEx(hDC, Left, Top + 1, Nil);
      Windows.LineTo(hDC, Left, Bottom - 1);
      // right line
      Windows.MoveToEx(hDC, Right - 1, Top + 1, Nil);
      Windows.LineTo(hDC, Right - 1, Bottom - 1);

      Windows.SetDCPenColor(hDC, rgb2bgr(BackColor) Shr 1 And $007F7F7F Or $00808080);
      // top light line
      Windows.MoveToEx(hDC, Left + 1, Top + 1, Nil);
      Windows.LineTo(hDC, Right - 1, Top + 1);
      // left light line
      Windows.MoveToEx(hDC, Left + 1, Top + 2, Nil);
      Windows.LineTo(hDC, Left + 1, Bottom - 2);

      Windows.SetDCPenColor(hDC, (rgb2bgr(BackColor) Shr 2 And $003F3F3F Shl 1) + (rgb2bgr(BackColor) Shr 2 And $003F3F3F));
      // bottom dark line
      Windows.MoveToEx(hDC, Left + 1, Bottom - 2, Nil);
      Windows.LineTo(hDC, Right - 1, Bottom - 2);
      // right dark line
      Windows.MoveToEx(hDC, Right - 2, Top + 2, Nil);
      Windows.LineTo(hDC, Right - 2, Bottom - 2);

      Inc(Left, 2); Inc(Top, 2); Dec(Right, 2); Dec(Bottom, 2);
    End;
    Windows.SetDCBrushColor(hDC, rgb2bgr(BackColor));
    Windows.FillRect(hDC, Rect, Windows.GetStockObject(DC_BRUSH));
End;

Procedure DrawButtonWithText(X, Y: Integer; Width, Height: Dword; Text: PChar; TextColor, ButtonColor, Flags: Dword);
Var
  TextHeight: Dword;
  Margin: LongInt;
Begin
  If LongBool(Flags And DT_CP866_8X16) Or
     LongBool(Flags And DT_UTF_16LE_8X16) Or
     LongBool(Flags And DT_UTF_8_8X16)
  Then
  Begin
    TextHeight := 16;
    Margin := 4;
  End
  Else
  Begin
    TextHeight := 9;
    Margin := 3;
  End;
  DrawButton(X, Y, Width, Height, ButtonColor);
  DrawText(Margin + X, (LongInt(Height - TextHeight + 1)) Shr 1 + Y, Text, TextColor, 0, Flags Or DT_ZSTRING, 0);
End;

Procedure DrawButtonsAndTexts(X, Y: LongInt);
Var
  Rect: Windows.TRect;
Const
  BUTTON1_HEIGHT = 25;
  BUTTON2_HEIGHT = 18;
Begin
  With Skin.StandardColors Do Begin
    DrawButtonWithText(X, Y, 120, BUTTON1_HEIGHT, 'Text on button', WorkButtonText, WorkButton, DT_CP866_8X16);
    DrawButtonWithText(X, Y + BUTTON1_HEIGHT + 5, 92, BUTTON2_HEIGHT, 'Text on button', WorkButtonText, WorkButton, DT_CP866_6X9);
    DrawText(X, Y + BUTTON1_HEIGHT + 10 + BUTTON2_HEIGHT, 'Text in window', WorkText, Work, DT_CP866_8X16 Or DT_ZSTRING Or DT_FILL_OPAQUE, 0);
    DrawText(X, Y + BUTTON1_HEIGHT + 10 + BUTTON2_HEIGHT + 16 + 5, 'Text in window', WorkText, Work, DT_CP866_6X9 Or DT_ZSTRING Or DT_FILL_OPAQUE, 0);
    With Rect Do Begin
      Left   := X + BORDER_SIZE;
      Top    := Y + BUTTON1_HEIGHT + 10 + BUTTON2_HEIGHT + 16 + 10 + 9 + LongInt(Skin.Height);
      Right  := Left + 80;
      Bottom := Top + 12;
    End;
    Windows.SetDCBrushColor(hDC, rgb2bgr(WorkGraph));
    Windows.FillRect(hDC, Rect, Windows.GetStockObject(DC_BRUSH));
  End;
End;

Type DrawSkinMode = (dsmActive, dsmInactive);

Procedure DrawSkin(Mode: DrawSkinMode);
Var
  PatternBrush:  Windows.HBRUSH;
  WRect:         Windows.TRect;
  FRect:         Windows.TRect;
  CompatibleDC:  Windows.HDC;
  InnerPoints:   Array [0..3] Of Windows.TPoint;
  OuterPoints:   Array [0..3] Of Windows.TPoint;
Begin

  PatternBrush := 0;
  Windows.GetClientRect(hWindow, WRect);

  Case Mode Of
    dsmActive:
      Begin
        PatternBrush := Windows.CreatePatternBrush(hBitmapMiddleActive);
        With FRect Do Begin
          Left   := LBitmapWidthActive;
          Top    := 0;
          Right  := Dword(WRect.Right) - RBitmapWidthActive;
          Bottom := Skin.Height;
        End;
      End;
    dsmInactive:
      Begin
        PatternBrush := Windows.CreatePatternBrush(hBitmapMiddleInactive);
        With FRect Do Begin
          Left   := LBitmapWidthInactive;
          Top    := 0;
          Right  := Dword(WRect.Right) - RBitmapWidthInactive;
          Bottom := Skin.Height;
        End;
      End;
  End;

  Windows.FillRect(hDC, FRect, PatternBrush);

  CompatibleDC := Windows.CreateCompatibleDC(hDC);

  Case Mode Of
    dsmActive:
      Begin
        Windows.SelectObject(CompatibleDC, hBitmapRightActive);
        Windows.BitBlt(hDC, Dword(WRect.Right) - RBitmapWidthActive, 0, RBitmapWidthActive, Skin.Height, CompatibleDC, 0, 0, SRCCOPY);
      End;
    dsmInactive:
      Begin
        Windows.SelectObject(CompatibleDC, hBitmapRightInactive);
        Windows.BitBlt(hDC, Dword(WRect.Right) - RBitmapWidthInactive, 0, RBitmapWidthInactive, Skin.Height, CompatibleDC, 0, 0, SRCCOPY);
      End;
  End;

  Case Mode Of
    dsmActive:
      Begin
        Windows.SelectObject(CompatibleDC, hBitmapLeftActive);
        Windows.BitBlt(hDC, 0, 0, LBitmapWidthActive, Skin.Height, CompatibleDC, 0, 0, SRCCOPY);
      End;
    dsmInactive:
      Begin
        Windows.SelectObject(CompatibleDC, hBitmapLeftInactive);
        Windows.BitBlt(hDC, 0, 0, LBitmapWidthInactive, Skin.Height, CompatibleDC, 0, 0, SRCCOPY);
      End;
  End;

  Windows.SelectObject(hDC, Windows.GetStockObject(DC_PEN));
  Windows.SelectObject(hdc, Windows.GetStockObject(DC_BRUSH));

  OuterPoints[0].X := 0;
  OuterPoints[0].Y := Skin.Height;
  OuterPoints[1].X := 0;
  OuterPoints[1].Y := WRect.Bottom - 1;
  OuterPoints[2].X := WRect.Right - 1;
  OuterPoints[2].Y := WRect.Bottom - 1;
  OuterPoints[3].X := WRect.Right - 1;
  OuterPoints[3].Y := Skin.Height - 1;

  InnerPoints[0].X := BORDER_SIZE - 1;
  InnerPoints[0].Y := Skin.Height;
  InnerPoints[1].X := BORDER_SIZE - 1;
  InnerPoints[1].Y := WRect.Bottom - BORDER_SIZE;
  InnerPoints[2].X := WRect.Right - BORDER_SIZE;
  InnerPoints[2].Y := WRect.Bottom - BORDER_SIZE;
  InnerPoints[3].X := WRect.Right - BORDER_SIZE;
  InnerPoints[3].Y := Skin.Height - 1;

  Case Mode Of
    dsmActive:
      Begin
        Windows.SetDCPenColor(hDC, rgb2bgr(Skin.Colors.Active.Outer));
        Windows.Polyline(hDC, OuterPoints, 4);
        Windows.SetDCPenColor(hDC, rgb2bgr(Skin.Colors.Active.Inner));
        Windows.Polyline(hDC, InnerPoints, 4);
        Windows.SetDCBrushColor(hDC, rgb2bgr(Skin.Colors.Active.Frame));
      End;
    dsmInactive:
      Begin
        Windows.SetDCPenColor(hDC, rgb2bgr(Skin.Colors.Inactive.Outer));
        Windows.Polyline(hDC, OuterPoints, 4);
        Windows.SetDCPenColor(hDC, rgb2bgr(Skin.Colors.Inactive.Inner));
        Windows.Polyline(hDC, InnerPoints, 4);
        Windows.SetDCBrushColor(hDC, rgb2bgr(Skin.Colors.Inactive.Frame));
      End;
  End;

  With FRect Do Begin
    Left   := OuterPoints[0].X + 1;
    Top    := Skin.Height;
    Right  := InnerPoints[0].X;
    Bottom := OuterPoints[2].Y;
    Windows.FillRect(hDC, FRect, Windows.GetStockObject(DC_BRUSH));
    Left   := InnerPoints[2].X + 1;
    Top    := Skin.Height;
    Right  := OuterPoints[3].X;
    Bottom := OuterPoints[2].Y;
    Windows.FillRect(hDC, FRect, Windows.GetStockObject(DC_BRUSH));
    Left   := InnerPoints[0].X;
    Top    := InnerPoints[1].Y + 1;
    Right  := InnerPoints[3].X + 1;
    Bottom := OuterPoints[2].Y;
    Windows.FillRect(hDC, FRect, Windows.GetStockObject(DC_BRUSH));
  End;

  Windows.DeleteObject(PatternBrush);
  Windows.DeleteDC(CompatibleDC);
End;

// -------------------------------------------------------------------------- //
Function PointInRect(X, Y, Left, Right, Top, Bottom: LongInt): Boolean;
Begin
  Result := (Left <= X) And (X <= Right) And
            (Top  <= Y) And (Y <= Bottom);
End;
// -------------------------------------------------------------------------- //
Procedure InvertButtonFrame(Button: PButton);
Begin
  If Button = Nil Then Exit;
  With Button^ Do Begin
    Windows.SetROP2(hDC, R2_NOT);
    // top line
    Windows.MoveToEx(hDC, Left + 1, Top, Nil);
    Windows.LineTo(hDC, Right - 1, Top);
    // bottom line
    Windows.MoveToEx(hDC, Left + 1, Bottom - 1, Nil);
    Windows.LineTo(hDC, Right - 1, Bottom - 1);
    // left line
    Windows.MoveToEx(hDC, Left, Top + 1, Nil);
    Windows.LineTo(hDC, Left, Bottom - 1);
    // right line
    Windows.MoveToEx(hDC, Right - 1, Top + 1, Nil);
    Windows.LineTo(hDC, Right - 1, Bottom - 1);
    Windows.SetROP2(hDC, R2_COPYPEN);
  End;
End;
// -------------------------------------------------------------------------- //

function WindowProc (hWindow: hwnd; Message: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
Var
  CursorPos: TPoint;
  WindowRect: TRect;
Begin
  Case Message Of
    WM_DESTROY:
      Begin
        PostQuitMessage (0);
        Result := 0;
      End;
    WM_LBUTTONDOWN, WM_RBUTTONDOWN, WM_MBUTTONDOWN,
    WM_NCLBUTTONDOWN, WM_NCRBUTTONDOWN, WM_NCMBUTTONDOWN:
      Begin
        Result := DefWindowProcA (hWindow, Message, wParam, lParam);

        If PointInRect(TSmallPoint(lParam).X, TSmallPoint(lParam).Y, ButtonMinimize.Left, ButtonMinimize.Right, ButtonMinimize.Top, ButtonMinimize.Bottom) Then
          CapturedButton := @ButtonMinimize
        Else
          If PointInRect(TSmallPoint(lParam).X, TSmallPoint(lParam).Y, ButtonClose.Left, ButtonClose.Right, ButtonClose.Top, ButtonClose.Bottom) Then
            CapturedButton := @ButtonClose
          Else
            CapturedButton := Nil;

        If CapturedButton <> Nil Then Begin
          Windows.SetCapture(hWindow);
          InvertButtonFrame(CapturedButton);
        End;

      End;
    WM_LBUTTONUP, WM_RBUTTONUP, WM_MBUTTONUP,
    WM_NCLBUTTONUP, WM_NCRBUTTONUP, WM_NCMBUTTONUP:
      Begin
        Result := DefWindowProcA (hWindow, Message, wParam, lParam);
        If Windows.GetCapture <> 0 Then Begin
          ReleaseCapture;
          InvertButtonFrame(CapturedButton);
          Case CapturedButton.ID Of
            BUTTON_MINIMIZE: Windows.ShowWindow(hWindow, SW_MINIMIZE);
            BUTTON_CLOSE:    Windows.PostQuitMessage(0);
          End;
        End;
      End;
    WM_PAINT, WM_SIZE, WM_ERASEBKGND:
      Begin
        GetClientRect(hWindow, WindowRect);
        With ButtonClose Do
          If LeftOffset < 0 Then Begin
            Left := WindowRect.Right + LeftOffset;
            Right := Left + LongInt(Width);
          End;
        With ButtonMinimize Do
          If LeftOffset < 0 Then Begin
            Left := WindowRect.Right + LeftOffset;
            Right := Left + LongInt(Width);
          End;
        RedrawWindow(hWindow, Nil, 0, RDW_INVALIDATE);
        If GetForegroundWindow = hWindow Then
          DrawSkin(dsmActive)
        Else
          DrawSkin(dsmInactive);
        DrawCaption(@CaptionText);
        DrawButtonsAndTexts(24, 32);
        Result := DefWindowProcA (hWindow, Message, wParam, lParam);
      End;
    WM_ACTIVATEAPP:
      Begin
        If wParam = 0 Then Begin
          DrawSkin(dsmInactive);
          DrawCaption(@CaptionText);
        End
        Else Begin
          RedrawWindow(hWindow, Nil, 0, RDW_INVALIDATE);
          //DrawSkin(dsmActive);
        End;
        Result := DefWindowProcA (hWindow, Message, wParam, lParam);
      End;
    WM_NCHITTEST:
      Begin
        Result := DefWindowProcA (hWindow, Message, wParam, lParam);
        Windows.GetCursorPos(CursorPos);
        Windows.ScreenToClient(hWindow, CursorPos);
        (* If Close Or Minimize Button under the Mouse pointer then assume client area *)
        If PointInRect(CursorPos.X, CursorPos.Y, ButtonMinimize.Left, ButtonMinimize.Right, ButtonMinimize.Top, ButtonMinimize.Bottom) Or
           PointInRect(CursorPos.X, CursorPos.Y, ButtonClose.Left, ButtonClose.Right, ButtonClose.Top, ButtonClose.Bottom) Then Begin
          Result := HTCLIENT;
          Exit;
        End;
        if Result = HTCLIENT then
        Begin
          //GetCursorPos(CursorPos);
          //ScreenToClient(hWindow, CursorPos);
          If CursorPos.Y < LongInt(Skin.Height) Then
            Result := HTCAPTION
          Else If WindowStyle = WS_SKINNED_SIZABLE Then
          Begin
            GetClientRect(hWindow, WindowRect);
            With WindowRect, CursorPos Do
            Begin
              If X < BORDER_SIZE Then
              Begin
                If Y > Bottom - BORDER_SIZE Then
                  Result := HTBOTTOMLEFT
                Else
                  Result := HTLEFT;
              End Else
              If X > Right - BORDER_SIZE  Then
              Begin
                If Y > Bottom - BORDER_SIZE Then
                  Result := HTBOTTOMRIGHT
                Else
                  Result := HTRIGHT;
              End Else
              If Y > Bottom - BORDER_SIZE Then
                Result := HTBOTTOM;
            End;
          End;
        End;
      End;
  Else
    Result := DefWindowProcA (hWindow, Message, wParam, lParam);
  End;
End;

Procedure LoadSkin;
Var
  i, x: Dword;
  hFile, FileLength, BytesRead: Dword;
  PFileBuffer: PSkinHeader;
  SkinParams: PSkinParams;
  SkinBitmaps: PSkinBitmaps;
  SkinButtons: PSkinButtons;
  SkinBitmap: PSkinBitmapStruct;
  FileName: PChar;
  OpenFile: CommDlg.TOpenFilename;
  tmpPtr: Pointer;
Begin

  If ParamCount <> 0 Then
    FileName := PChar(ParamStr(1))
  Else Begin
    FileName := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, MAX_PATH);
    With OpenFile Do Begin
      lStructSize := SizeOf(TOpenFilename);
      lpstrFile := FileName;
      lpstrFilter :=  'Skin files(*.skn)'#0'*.skn'#0#0;
      lpstrTitle := #0;
      nMaxFile := MAX_PATH;
      Flags := OFN_FILEMUSTEXIST + OFN_PATHMUSTEXIST + OFN_HIDEREADONLY;
      If CommDlg.GetOpenFileName(OpenFile) Then
        ShellAPI.ShellExecute(0, Nil, PChar(ParamStr(0)), PChar('"' + lpstrFile + '"'), Nil, SW_SHOWNORMAL);
    End;
    Windows.ExitProcess(0);
  End;

  hFile := Windows.CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, Nil, OPEN_EXISTING, 0, 0);
  If hFile <> $ffffffff Then
  Begin
    FileLength := Windows.GetFileSize(hFile, Nil);
    PFileBuffer := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, FileLength);
    If Not Windows.ReadFile(hFile, PFileBuffer^, FileLength, BytesRead, Nil) Then Begin
      Windows.MessageBox(0, 'ReadFile error.', '', 0);
      Windows.ExitProcess(1);
    End
    Else Begin

      If MemCmp(PFileBuffer^.Signature, 'SKIN', 4) <> 0 Then
        If MemCmp(PFileBuffer^.Signature, 'KPCK', 4) = 0 Then
        Begin
          tmpPtr := Windows.HeapAlloc(GetProcessHeap, 0, FileLength);
          MemCpy(tmpPtr^, PFileBuffer^, FileLength);
          Windows.HeapFree(GetProcessHeap, 0, PFileBuffer);
          PFileBuffer := Windows.HeapAlloc(GetProcessHeap, 0, PPackedFile(PFileBuffer)^.UnpackedSize);
          UnPack(tmpPtr^, PFileBuffer^);
          Windows.HeapFree(GetProcessHeap, 0, tmpPtr);
          If MemCmp(PFileBuffer^.Signature, 'SKIN', 4) <> 0 Then
          Begin
            Windows.MessageBox(0, 'Not KolibriOS skin.', '', 0);
            Windows.ExitProcess(1);
          End;
        End
        Else
        Begin
          Windows.MessageBox(0, 'Not KolibriOS skin.', '', 0);
          Windows.ExitProcess(1);
        End;

      With PFileBuffer^ Do Begin
        SkinParams  := PSkinParams(Dword(Params)   + Dword(PFileBuffer));
        SkinBitmaps := PSkinBitmaps(Dword(Bitmaps) + Dword(PFileBuffer));
        SkinButtons := PSkinButtons(Dword(Buttons) + Dword(PFileBuffer));
        With SkinParams^ Do Begin
          Skin.Height := Height;
          With Skin.Margins Do Begin
            Right   := Margins.Right;
            Left    := Margins.Left;
            Bottom  := Margins.Bottom;
            Top     := Margins.Top;
          End;
          With Colors Do Begin
            With Active Do Begin
              Skin.Colors.Active.Inner := Inner;
              Skin.Colors.Active.Outer := Outer;
              Skin.Colors.Active.Frame := Frame;
            End;
            With Inactive Do Begin
              Skin.Colors.Inactive.Inner := Inner;
              Skin.Colors.Inactive.Outer := Outer;
              Skin.Colors.Inactive.Frame := Frame;
            End;
          End;
          With StandardColors Do Begin
            Skin.StandardColors.Work           := Work;
            Skin.StandardColors.WorkGraph      := WorkGraph;
            Skin.StandardColors.WorkText       := WorkText;
            Skin.StandardColors.WorkButtonText := WorkButtonText;
            Skin.StandardColors.WorkButton     := WorkButton;
            Skin.StandardColors.GrabText       := GrabText;
          End;
        End;
        i := 0;
        While SkinButtons[i].Mode <> 0 Do Begin
          Case SkinButtons[i].Mode Of
            SKIN_BUTTON_CLOSE:
              Begin
                With ButtonClose Do Begin
                  Left       := SkinButtons[i].Left;
                  Top        := SkinButtons[i].Top;
                  Right      := Left + SkinButtons[i].Width;
                  Bottom     := Top + SkinButtons[i].Height;
                  Width      := SkinButtons[i].Width;
                  LeftOffset := SkinButtons[i].Left;
                  ID         := BUTTON_CLOSE;
                End;
              End;
            SKIN_BUTTON_MINIMIZE:
              Begin
                With ButtonMinimize Do Begin
                  Left       := SkinButtons[i].Left;
                  Top        := SkinButtons[i].Top;
                  Right      := Left + SkinButtons[i].Width;
                  Bottom     := Top + SkinButtons[i].Height;
                  Width      := SkinButtons[i].Width;
                  LeftOffset := SkinButtons[i].Left;
                  ID         := BUTTON_MINIMIZE;
                End;
              End;
          End;
          Inc(i);
        End;
        i := 0;
        While SkinBitmaps[i].Pose <> 0 Do Begin
          With SkinBitmaps[i] Do Begin
            SkinBitmap := PSkinBitmapStruct(Dword(Bitmap) + Dword(PFileBuffer));
            With SkinBitmap^ Do Begin

              If (Pose = SKIN_BITMAP_POSE_LEFT ) And (Mode = SKIN_BITMAP_MODE_ACTIVE)   Then LBitmapWidthActive   := Width;
              If (Pose = SKIN_BITMAP_POSE_RIGHT) And (Mode = SKIN_BITMAP_MODE_ACTIVE)   Then RBitmapWidthActive   := Width;
              If (Pose = SKIN_BITMAP_POSE_LEFT ) And (Mode = SKIN_BITMAP_MODE_INACTIVE) Then LBitmapWidthInactive := Width;
              If (Pose = SKIN_BITMAP_POSE_RIGHT) And (Mode = SKIN_BITMAP_MODE_INACTIVE) Then RBitmapWidthInactive := Width;

              Case Pose Of
                SKIN_BITMAP_POSE_LEFT:
                  Case Mode Of
                    SKIN_BITMAP_MODE_ACTIVE:
                      Begin
                        With laBMPInfo.bmiHeader Do Begin
                          biSize          := SizeOf(laBMPInfo.bmiHeader);
                          biWidth         := Width;
                          biHeight        := -Height;
                          biBitCount      := 32;
                          biCompression   := BI_RGB;
                          biPlanes        := 1;
                          tmpBytesLeftActive := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, Width * Height * 4);
                          For x := 0 To Width * Height - 1 Do Begin
                            tmpBytesLeftActive[x].rgbRed      := Raw[x].rgbtRed;
                            tmpBytesLeftActive[x].rgbGreen    := Raw[x].rgbtGreen;
                            tmpBytesLeftActive[x].rgbBlue     := Raw[x].rgbtBlue;
                            tmpBytesLeftActive[x].rgbReserved := 0;
                          End;
                        End;
                      End;
                    SKIN_BITMAP_MODE_INACTIVE:
                      Begin
                        With liBMPInfo.bmiHeader Do Begin
                          biSize          := SizeOf(liBMPInfo.bmiHeader);
                          biWidth         := Width;
                          biHeight        := -Height;
                          biBitCount      := 32;
                          biCompression   := BI_RGB;
                          biPlanes        := 1;
                          tmpBytesLeftInactive := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, Width * Height * 4);
                          For x := 0 To Width * Height - 1 Do Begin
                            tmpBytesLeftInactive[x].rgbRed      := Raw[x].rgbtRed;
                            tmpBytesLeftInactive[x].rgbGreen    := Raw[x].rgbtGreen;
                            tmpBytesLeftInactive[x].rgbBlue     := Raw[x].rgbtBlue;
                            tmpBytesLeftInactive[x].rgbReserved := 0;
                          End;
                        End;
                      End;
                  End;
                SKIN_BITMAP_POSE_RIGHT:
                  Case Mode Of
                    SKIN_BITMAP_MODE_ACTIVE:
                      Begin
                        With raBMPInfo.bmiHeader Do Begin
                          biSize          := SizeOf(raBMPInfo.bmiHeader);
                          biWidth         := Width;
                          biHeight        := -Height;
                          biBitCount      := 32;
                          biCompression   := BI_RGB;
                          biPlanes        := 1;
                          tmpBytesRightActive := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, Width * Height * 4);
                          For x := 0 To Width * Height - 1 Do Begin
                            tmpBytesRightActive[x].rgbRed      := Raw[x].rgbtRed;
                            tmpBytesRightActive[x].rgbGreen    := Raw[x].rgbtGreen;
                            tmpBytesRightActive[x].rgbBlue     := Raw[x].rgbtBlue;
                            tmpBytesRightActive[x].rgbReserved := 0;
                          End;
                        End;
                      End;
                    SKIN_BITMAP_MODE_INACTIVE:
                      Begin
                        With riBMPInfo.bmiHeader Do Begin
                          biSize          := SizeOf(riBMPInfo.bmiHeader);
                          biWidth         := Width;
                          biHeight        := -Height;
                          biBitCount      := 32;
                          biCompression   := BI_RGB;
                          biPlanes        := 1;
                          tmpBytesRightInactive := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, Width * Height * 4);
                          For x := 0 To Width * Height - 1 Do Begin
                            tmpBytesRightInactive[x].rgbRed      := Raw[x].rgbtRed;
                            tmpBytesRightInactive[x].rgbGreen    := Raw[x].rgbtGreen;
                            tmpBytesRightInactive[x].rgbBlue     := Raw[x].rgbtBlue;
                            tmpBytesRightInactive[x].rgbReserved := 0;
                          End;
                        End;

                      End;
                  End;
                SKIN_BITMAP_POSE_MIDDLE:
                  Case Mode Of
                    SKIN_BITMAP_MODE_ACTIVE:
                      Begin
                        With maBMPInfo.bmiHeader Do Begin
                          biSize          := SizeOf(maBMPInfo.bmiHeader);
                          biWidth         := Width;
                          biHeight        := -Height;
                          biBitCount      := 32;
                          biCompression   := BI_RGB;
                          biPlanes        := 1;
                          tmpBytesMiddleActive := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, Width * Height * 4);
                          For x := 0 To Width * Height - 1 Do Begin
                            tmpBytesMiddleActive[x].rgbRed      := Raw[x].rgbtRed;
                            tmpBytesMiddleActive[x].rgbGreen    := Raw[x].rgbtGreen;
                            tmpBytesMiddleActive[x].rgbBlue     := Raw[x].rgbtBlue;
                            tmpBytesMiddleActive[x].rgbReserved := 0;
                          End;
                        End;
                      End;
                    SKIN_BITMAP_MODE_INACTIVE:
                      Begin
                        With miBMPInfo.bmiHeader Do Begin
                          biSize          := SizeOf(miBMPInfo.bmiHeader);
                          biWidth         := Width;
                          biHeight        := -Height;
                          biBitCount      := 32;
                          biCompression   := BI_RGB;
                          biPlanes        := 1;
                          tmpBytesMiddleInactive := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, Width * Height * 4);
                          For x := 0 To Width * Height - 1 Do Begin
                            tmpBytesMiddleInactive[x].rgbRed      := Raw[x].rgbtRed;
                            tmpBytesMiddleInactive[x].rgbGreen    := Raw[x].rgbtGreen;
                            tmpBytesMiddleInactive[x].rgbBlue     := Raw[x].rgbtBlue;
                            tmpBytesMiddleInactive[x].rgbReserved := 0;
                          End;
                        End;
                      End;
                  End;
              End;
            End;
            Inc(i);
          End;
        End;
      End;
    End;
  End
  Else Begin
    Windows.MessageBox(0, 'Can not open file.', '', 0);
    Windows.ExitProcess(1);
  End;
End;

Procedure SetCaptionText;
Var i: Dword;
Begin
  i := 0;
  While PChar(ParamStr(1))[i] <> #0  Do Inc(i);
  While PChar(ParamStr(1))[i] <> '\' Do Dec(i);
  StrCpy(CaptionText, PChar(ParamStr(1))[i + 1]);
End;

Begin
  LoadSkin;
  SetCaptionText;
  WLeft := (Windows.GetSystemMetrics(SM_CXSCREEN) - WWidth)  Shr 1;
  WTop  := (Windows.GetSystemMetrics(SM_CYSCREEN) - WHeight) Shr 1;
  With WindowClass Do
  Begin
    Style         := CS_HREDRAW + CS_VREDRAW;
    lpfnWndProc   := @WindowProc;
    cbClsExtra    := 0;
    cbWndExtra    := 0;
    hInstance     := Windows.GetModuleHandle(Nil);
    hIcon         := Windows.LoadIcon(hInstance, 'skinner_ico');
    hCursor       := Windows.LoadCursor(0, IDC_ARROW);
    hbrBackground := Windows.CreateSolidBrush(rgb2bgr(Skin.StandardColors.Work));
    lpszMenuName  := Nil;
    lpszClassName := 'WindowClass';
    Windows.RegisterClass(WindowClass);
    hWindow := Windows.CreateWindow(lpszClassName, 'KolibriOS skin viewer', WS_VISIBLE + WS_POPUP + WS_MAXIMIZEBOX, WLeft, WTop, WWidth, WHeight, 0, 0, hInstance, Nil);
    hDC := Windows.GetDC(hWindow);
  End;

  hBitmapMiddleActive   := Windows.CreateCompatibleBitmap(hDC, maBMPInfo.bmiHeader.biWidth, -maBMPInfo.bmiHeader.biHeight);
  hBitmapLeftActive     := Windows.CreateCompatibleBitmap(hDC, laBMPInfo.bmiHeader.biWidth, -laBMPInfo.bmiHeader.biHeight);
  hBitmapRightActive    := Windows.CreateCompatibleBitmap(hDC, raBMPInfo.bmiHeader.biWidth, -raBMPInfo.bmiHeader.biHeight);

  hBitmapMiddleInactive := Windows.CreateCompatibleBitmap(hDC, miBMPInfo.bmiHeader.biWidth, -miBMPInfo.bmiHeader.biHeight);
  hBitmapLeftInactive   := Windows.CreateCompatibleBitmap(hDC, liBMPInfo.bmiHeader.biWidth, -liBMPInfo.bmiHeader.biHeight);
  hBitmapRightInactive  := Windows.CreateCompatibleBitmap(hDC, riBMPInfo.bmiHeader.biWidth, -riBMPInfo.bmiHeader.biHeight);

  Windows.SetDIBits(hDC, hBitmapMiddleActive,   0, -maBMPInfo.bmiHeader.biHeight, tmpBytesMiddleActive,   maBMPInfo, DIB_RGB_COLORS);
  Windows.SetDIBits(hDC, hBitmapLeftActive,     0, -laBMPInfo.bmiHeader.biHeight, tmpBytesLeftActive,     laBMPInfo, DIB_RGB_COLORS);
  Windows.SetDIBits(hDC, hBitmapRightActive,    0, -raBMPInfo.bmiHeader.biHeight, tmpBytesRightActive,    raBMPInfo, DIB_RGB_COLORS);

  Windows.SetDIBits(hDC, hBitmapMiddleInactive, 0, -miBMPInfo.bmiHeader.biHeight, tmpBytesMiddleInactive, miBMPInfo, DIB_RGB_COLORS);
  Windows.SetDIBits(hDC, hBitmapLeftInactive,   0, -liBMPInfo.bmiHeader.biHeight, tmpBytesLeftInactive,   liBMPInfo, DIB_RGB_COLORS);
  Windows.SetDIBits(hDC, hBitmapRightInactive,  0, -riBMPInfo.bmiHeader.biHeight, tmpBytesRightInactive,  riBMPInfo, DIB_RGB_COLORS);

  Windows.HeapFree(GetProcessHeap, 0, tmpBytesMiddleActive);
  Windows.HeapFree(GetProcessHeap, 0, tmpBytesLeftActive);
  Windows.HeapFree(GetProcessHeap, 0, tmpBytesRightActive);

  Windows.HeapFree(GetProcessHeap, 0, tmpBytesMiddleInactive);
  Windows.HeapFree(GetProcessHeap, 0, tmpBytesLeftInactive);
  Windows.HeapFree(GetProcessHeap, 0, tmpBytesRightInactive);

  While GetMessage(Msg, 0, 0, 0) Do
  Begin
    TranslateMessage(Msg);
    DispatchMessage(Msg);
  End;
End.